Imports System.Web.Security
Imports System.Text
Imports System.Text.RegularExpressions

Public Class SignIn
  Inherits System.Web.UI.UserControl
  Protected WithEvents AnonymousControls As System.Web.UI.HtmlControls.HtmlTable
  Protected WithEvents AuthenticatedControls As System.Web.UI.HtmlControls.HtmlTable
  Protected WithEvents SignOutButton As System.Web.UI.WebControls.LinkButton

#Region " Web Form Designer Generated Code "

  'This call is required by the Web Form Designer.
  <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

  End Sub
  Protected WithEvents UsernameTextBox As System.Web.UI.WebControls.TextBox
  Protected WithEvents PasswordTextBox As System.Web.UI.WebControls.TextBox
  Protected WithEvents SignInButton As System.Web.UI.WebControls.LinkButton
  Protected WithEvents UsernameValidator As System.Web.UI.WebControls.RegularExpressionValidator
  Protected WithEvents PasswordValidator As System.Web.UI.WebControls.RegularExpressionValidator
  Protected WithEvents UsernameLabel As System.Web.UI.WebControls.Label

  'NOTE: The following placeholder declaration is required by the Web Form Designer.
  'Do not delete or move it.
  Private designerPlaceholderDeclaration As System.Object

  Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
    'CODEGEN: This method call is required by the Web Form Designer
    'Do not modify it using the code editor.
    InitializeComponent()
  End Sub

#End Region

  Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    'check whether the user is authenticated
    If Request.IsAuthenticated Then
      'the user is authenticated, so display the authenticated controls
      AnonymousControls.Visible = False
      AuthenticatedControls.Visible = True

      'populate the username display
      UsernameLabel.Text = Context.User.Identity.Name
    Else
      'the user is not authenticated, so display the anonymous controls
      AnonymousControls.Visible = True
      AuthenticatedControls.Visible = False
    End If
  End Sub

  Private Sub SignInButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SignInButton.Click

    Dim valid As Boolean = True
    Dim c As Control
    Dim v As BaseValidator

    'loop through all validators on the page
    For Each v In Page.Validators
      'check whether the validator is attached to this user control
      If Not Me.FindControl(v.ControlToValidate) Is Nothing Then
        'validate the control
        v.Validate()
        'check whether the control validated successfully
        If Not v.IsValid Then
          'if it did not validate, set valid to false
          valid = False
        End If
      End If
    Next

    'only proceed with sign in if the controls on this user control are valid
    If valid Then
      'authenticate the user against the credentials stored in the web.config
      'if you use a different credentials store, check against that here
      If FormsAuthentication.Authenticate(UsernameTextBox.Text, _
                                          PasswordTextBox.Text) Then

        'set the authentication cookie
        FormsAuthentication.SetAuthCookie(UsernameTextBox.Text, True)

        'get an authentication ticket
        Dim ticket As New FormsAuthenticationTicket(UsernameTextBox.Text, _
                                                    False, 30)
        'encrypt the ticket
        Dim encryptedTicket As String = FormsAuthentication.Encrypt(ticket)

        'refresh the page with the authentication ticket added
        Dim currentUrl As New StringBuilder(Request.Url.PathAndQuery)

        'check whether there is already a query string
        If currentUrl.ToString.IndexOf("?") = -1 Then
          'there is not a query string, so add one
          currentUrl.Append("?")
        Else
          'there is a query string, so add the parameter to it
          currentUrl.Append("&")
        End If
        currentUrl.Append(FormsAuthentication.FormsCookieName)
        currentUrl.Append("=")
        currentUrl.Append(encryptedTicket)

        Response.Redirect(currentUrl.ToString)
      End If
    End If

  End Sub

  Private Sub SignOutButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SignOutButton.Click

    'remove the authentication cookie
    FormsAuthentication.SignOut()

    'now we need to ensure the ticket is removed from the URL...

    'get current URL without query string parameters
    Dim currentUrl As New StringBuilder(Request.Url.LocalPath)

    'we now need to add each query string parameter except the auth ticket
    'back onto the URL
    Dim parameterName As String
    Dim firstParameter As Boolean = True
    For Each parameterName In Request.QueryString.AllKeys
      'check that this is not the ticket
      If Not parameterName = FormsAuthentication.FormsCookieName Then
        'if this is the first parameter start a query string
        If firstParameter Then
          currentUrl.Append("?")
        Else
          'this is not the first parameter, so continue the query string
          currentUrl.Append("&")
        End If
        'add the parameter
        currentUrl.Append(parameterName)
        currentUrl.Append("=")
        currentUrl.Append(Request.QueryString.Item(parameterName))
      End If
    Next

    'redirect to the URL with the ticket removed
    Response.Redirect(currentUrl.ToString)
  End Sub
End Class
