Imports System.Security.Principal

Public Class IPAuthenticationModule
  Implements IHttpModule

  Public Sub Dispose() Implements System.Web.IHttpModule.Dispose
    'we have no resources to dispose of
  End Sub

  Public Sub Init(ByVal context As System.Web.HttpApplication) _
                        Implements System.Web.IHttpModule.Init
    'handle the AuthenticateRequest of the application
    AddHandler context.AuthenticateRequest, AddressOf Me.Authenticate
  End Sub

  Public Sub Authenticate(ByVal sender As Object, ByVal e As EventArgs)
    Dim application As HttpApplication = CType(sender, HttpApplication)

    'check that the user has not been created or is not authenticated
    If application.Context.User Is Nothing _
          OrElse Not application.Context.User.Identity.IsAuthenticated Then

      'create identity and principal objects
      Dim identity As New IPIdentity(application.Request.UserHostAddress)
      Dim principal As New GenericPrincipal(identity, New String() {})

      'attach the principal to the application context
      application.Context.User = principal

    End If
  End Sub

End Class
