Public Class IPIdentity
  Implements System.Security.Principal.IIdentity

  Private _IP As String = Nothing

  Public Sub New(ByVal ip As String)
    _IP = ip
  End Sub

  'do not allow an IPIdentity to be created without an IP address
  Private Sub New()
  End Sub

  Public ReadOnly Property AuthenticationType() As String Implements System.Security.Principal.IIdentity.AuthenticationType
    Get
      Return "IP"
    End Get
  End Property

  Public ReadOnly Property IsAuthenticated() As Boolean Implements System.Security.Principal.IIdentity.IsAuthenticated
    Get
      'An IP Identity will only be used when authentication is successful
      Return True
    End Get
  End Property

  Public ReadOnly Property Name() As String Implements System.Security.Principal.IIdentity.Name
    Get
      Return _IP
    End Get
  End Property
End Class
