Imports System.Web.Security
Imports System.Text

Public Class SignIn
  Inherits System.Web.UI.UserControl
  Protected WithEvents AnonymousControls As System.Web.UI.HtmlControls.HtmlTable
  Protected WithEvents AuthenticatedControls As System.Web.UI.HtmlControls.HtmlTable
  Protected WithEvents SignOutButton As System.Web.UI.WebControls.LinkButton

#Region " Web Form Designer Generated Code "

  'This call is required by the Web Form Designer.
  <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

  End Sub
  Protected WithEvents UsernameTextBox As System.Web.UI.WebControls.TextBox
  Protected WithEvents PasswordTextBox As System.Web.UI.WebControls.TextBox
  Protected WithEvents SignInButton As System.Web.UI.WebControls.LinkButton
  Protected WithEvents UsernameValidator As System.Web.UI.WebControls.RegularExpressionValidator
  Protected WithEvents PasswordValidator As System.Web.UI.WebControls.RegularExpressionValidator
  Protected WithEvents UsernameLabel As System.Web.UI.WebControls.Label

  'NOTE: The following placeholder declaration is required by the Web Form Designer.
  'Do not delete or move it.
  Private designerPlaceholderDeclaration As System.Object

  Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
    'CODEGEN: This method call is required by the Web Form Designer
    'Do not modify it using the code editor.
    InitializeComponent()
  End Sub

#End Region

  Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    'check whether the user is authenticated
    If Request.IsAuthenticated Then
      'the user is authenticated, so display the authenticated controls
      AnonymousControls.Visible = False
      AuthenticatedControls.Visible = True

      'populate the username display
      UsernameLabel.Text = Context.User.Identity.Name
    Else
      'the user is not authenticated, so display the anonymous controls
      AnonymousControls.Visible = True
      AuthenticatedControls.Visible = False
    End If
  End Sub

  Private Sub SignInButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SignInButton.Click

    Dim valid As Boolean = True
    Dim c As Control
    Dim v As BaseValidator

    'loop through all validators on the page
    For Each v In Page.Validators
      'check whether the validator is attached to this user control
      If Not Me.FindControl(v.ControlToValidate) Is Nothing Then
        'validate the control
        v.Validate()
        'check whether the control validated successfully
        If Not v.IsValid Then
          'if it did not validate, set valid to false
          valid = False
        End If
      End If
    Next

    'only proceed with sign in if the controls on this user control are valid
    If valid Then
      'authenticate the user against the credentials stored in the web.config
      'if you use a different credentials store, check against that here
      If FormsAuthentication.Authenticate(UsernameTextBox.Text, PasswordTextBox.Text) Then

        'get the roles
        Dim roles() As String = BusinessLogic.GetRoles(UsernameTextBox.Text)

        'create a semicolon delimited string of roles
        Dim rolesBuilder As New StringBuilder
        For Each role As String In roles
          rolesBuilder.Append(role)
          rolesBuilder.Append(";")
        Next

        'create the auth ticket
        Dim ticket As New FormsAuthenticationTicket(1, _
                                                    UsernameTextBox.Text, _
                                                    DateTime.Now, _
                                                    DateTime.Now.AddDays(7), _
                                                    True, _
                                                    rolesBuilder.ToString)

        'encrypt the ticket
        Dim ticketString As String = FormsAuthentication.Encrypt(ticket)

        'put the ticket in a cookie
        Dim cookie As New HttpCookie(FormsAuthentication.FormsCookieName, _
                                     ticketString)

        'add the cookie to the response
        Response.Cookies.Add(cookie)

        'refresh the page
        Response.Redirect(Request.Url.PathAndQuery)
      End If
    End If

  End Sub

  Private Sub SignOutButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SignOutButton.Click
    FormsAuthentication.SignOut()
    Response.Redirect(Request.Url.PathAndQuery)
  End Sub
End Class
