using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Xml;
using System.Xml.XPath;

namespace XMLChapterCS {
	/// <summary>
	/// Summary description for Listing13.
	/// </summary>
	public class Listing13 : System.Web.UI.Page {
		protected System.Web.UI.WebControls.Label lblOutput;
	
		private void Page_Load(object sender, System.EventArgs e) {
			string xmlPath = Server.MapPath("Listing13.xml");
			//Load XML
			XPathDocument doc = new XPathDocument(xmlPath);
			//Create navigator
			XPathNavigator nav = doc.CreateNavigator();
			XmlNamespaceManager ns = new XmlNamespaceManager(nav.NameTable);
			//Define default namespace.  Prefix can be any valid XML namespace
			//prefix value
			ns.AddNamespace("ns","http://www.moreover.com");
			//Add default prefix into xpath statement to account for 
			//default namespace
			string xpath = "/ns:moreovernews/ns:article/" +
				"ns:headline_text";
			//Create a compiled xpath statement and set context to include
			//the namespace manager data.
			XPathExpression exp = nav.Compile(xpath);
			exp.SetContext(ns);
			//Select nodes and write out the headlines
			XPathNodeIterator it = nav.Select(exp);
			while (it.MoveNext()) {
				lblOutput.Text += it.Current.Value + "<br />";
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e) {
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
