using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Xml;
using System.Xml.XPath;

namespace XMLChapterCS {
	/// <summary>
	/// Summary description for Listing14.
	/// </summary>
	public class Listing14 : System.Web.UI.Page {
		protected System.Web.UI.WebControls.Label lblNoNamespace;
		protected System.Web.UI.WebControls.Label lblLocalNS;
	
		private void Page_Load(object sender, System.EventArgs e) {
			string xmlPath = Server.MapPath("Listing14.xml");
			//Load XML
			XPathDocument doc = new XPathDocument(xmlPath);
			//Create navigator
			XPathNavigator nav = doc.CreateNavigator();
			XmlNamespaceManager ns = new XmlNamespaceManager(nav.NameTable);
			//Define news namespace prefix and URK.
			ns.AddNamespace("news","http://www.moreover.com");
			//Add news prefix into xpath statement
			string xpathNS = "/moreovernews/news:article/headline_text";
			//Create a compiled xpath statement and set context to include
			//the namespace manager data.
			XPathExpression exp = nav.Compile(xpathNS);
			exp.SetContext(ns);
			//Select nodes and write out the headlines
			XPathNodeIterator it = nav.Select(exp);
			while (it.MoveNext()) {
				this.lblLocalNS.Text += it.Current.Value + "<br />";
			}

			//Locate articles not in the http://www.moreover.com namespace
			string xpathDefault = "/moreovernews/article/headline_text";
			XPathExpression expDefault = nav.Compile(xpathDefault);
			expDefault.SetContext(ns);
			//Select nodes and write out the headlines
			XPathNodeIterator it2 = nav.Select(expDefault);
			while (it2.MoveNext()) {
				this.lblNoNamespace.Text += it2.Current.Value + "<br />";
			}

		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e) {
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
