using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Xml;

namespace XMLChapterCS {
	/// <summary>
	/// Summary description for Listing15.
	/// </summary>
	public class Listing15 : System.Web.UI.Page {
		protected System.Web.UI.WebControls.Label lblLocalNS;
		protected System.Web.UI.WebControls.Label lblNoNamespace;
	
		private void Page_Load(object sender, System.EventArgs e) {
			string xmlPath = Server.MapPath("Listing14.xml");
			XmlDocument doc = new XmlDocument();
			doc.Load(xmlPath);
			XmlNamespaceManager ns = new XmlNamespaceManager(doc.NameTable);
			ns.AddNamespace("news","http://www.moreover.com");
			string xpathLocal = "/moreovernews/news:article/headline_text";
			XmlNodeList newsNodes = doc.SelectNodes(xpathLocal,ns);
			foreach (XmlNode newsNode in newsNodes) {
				this.lblLocalNS.Text += newsNode.InnerText + "<br />";
			}

			//Select nodes not in http://www.moreover.com namespace
			string xpathDefault = "/moreovernews/article/headline_text";
			XmlNodeList nonNSNodes = doc.SelectNodes(xpathDefault);
			foreach (XmlNode newsNode in nonNSNodes) {
				this.lblNoNamespace.Text += newsNode.InnerText + "<br />";
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e) {
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
