using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Xml;
using System.IO;

namespace XMLChapterCS {
	/// <summary>
	/// Summary description for Listing1.
	/// </summary>
	public class Listing2 : System.Web.UI.Page {
		protected System.Web.UI.WebControls.Label lblNews;
	
		private void Page_Load(object sender, System.EventArgs e) {
			string url = "http://p.moreover.com/cgi-local/page?c=XML%20and%20metadata%20news&o=xml";
			//Create backing store where XmlWriter writes to
			StringWriter sw = new StringWriter();
			XmlTextWriter writer = new XmlTextWriter(sw);
			writer.Formatting = Formatting.Indented;
			XmlTextReader reader = null;
			try {
				writer.WriteStartElement("ul"); 				
				//Parse XML using the XmlReader stream API
				reader = new XmlTextReader(url); 
				reader.XmlResolver = null; //Prevent DTD from being resolved
				string headline_url = null;
				Trace.Warn("Start Render");
				while (reader.Read()) {
					//Locate only start elements
					if (reader.NodeType == XmlNodeType.Element) {
						switch (reader.Name) {				
							case "url":
								headline_url = reader.ReadString(); //Store URL
								break;				
							case "headline_text":
								string headline = reader.ReadString();
								//Filter out headlines that don't have xml keyword in them
								//Could also use a regex here instead of IndexOf
								if (headline.ToLower().IndexOf("xml") != -1) {
									writer.WriteStartElement("li");
									writer.WriteStartElement("a");
									writer.WriteAttributeString("href",headline_url);
									writer.WriteAttributeString("target","_blank");
									writer.WriteString(headline);
									writer.WriteEndElement(); //</a>
									writer.WriteEndElement(); //</li>									
								}
								break;
						}
					}
				}
				writer.WriteEndElement(); //</ul> tag
				//Update Label
				this.lblNews.Text = sw.ToString();
			}
			catch (Exception exp) {
				this.lblNews.Text = exp.Message;
			}
			finally {
				reader.Close();
				writer.Close();
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e) {
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}