using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Text;
using System.Xml.XPath;

namespace XMLChapterCS {
	/// <summary>
	/// Summary description for Listing8.
	/// </summary>
	public class Listing8 : System.Web.UI.Page {
		protected System.Web.UI.WebControls.Label lblOutput;
		StringBuilder sb = new StringBuilder();
		private void Page_Load(object sender, System.EventArgs e) {
			NavigateBooks();
		}

		private void NavigateBooks() {
			string xmlPath = Server.MapPath("Listing7.xml");
			//Load XML into a non-editable structure
			//This is more efficient than the DOM
			XPathDocument doc = new XPathDocument(xmlPath);
			//Create XPathNavigator by calling CreateNavigator() method
			XPathNavigator nav = doc.CreateNavigator();
			//Move to document
			nav.MoveToRoot();
			//Move to root element - bookstore
			nav.MoveToFirstChild();
			//Move to first book child element
			if (nav.MoveToFirstChild()) {
				do { //Walk through book elements
					WalkSiblings(nav);					
				} while (nav.MoveToNext());
			}
			//Write out data found while navigating doc
			lblOutput.Text = sb.ToString();
		}

		private void WalkSiblings(XPathNavigator nav) {
			//Move to "title" element and get value
			string firstName = String.Empty;
			string lastName = String.Empty;
			nav.MoveToFirstChild();
			string title = nav.Value;
			sb.Append(title + "<br />");
			//Move back to book element
			nav.MoveToParent();
			//access author element under book
			XPathNodeIterator authorNode = 
				nav.SelectChildren("author","");
			while (authorNode.MoveNext()) {
				//Move to first-name element
				authorNode.Current.MoveToFirstChild();
				firstName = authorNode.Current.Value;
				//Move to last-name element
				authorNode.Current.MoveToNext();
				lastName = authorNode.Current.Value;
				sb.Append(firstName + " " + lastName + "<br />");
			}

			//Now move to price element
			XPathNodeIterator priceNode = nav.SelectChildren("price","");
			priceNode.MoveNext();
			//Write out value of price element
			sb.Append("$" + priceNode.Current.Value + "<br />");


			//Access other books by author
			//This demonstrates how we can move anywhere in the doc
			XPathNodeIterator otherBookNodes = 
				nav.Select("//book[author/first-name='" +
				firstName + "' and author/last-name='" +
				lastName + "' and title != \"" +
				title + "\"]/title");
			sb.Append("<i>Other Books:</i> <br />");
			//Add other books to output
			if (otherBookNodes.Count > 0) {
				while (otherBookNodes.MoveNext()) {
					sb.Append(otherBookNodes.Current.Value + "<br />");
				}
			} else {
				sb.Append("None");
			}
			sb.Append("<p />");
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e) {
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
