Imports System.Xml
Imports System.IO

Public Class CDataSet : Inherits DataSet

  Public Overloads Function GetXml(ByVal cdataSections() As String) As String
    Return InsertCDATASections(cdataSections)
  End Function

  Private Function InsertCDATASections(ByVal cdataSections() As String) As String
    'Convert to XML with expanded general entities and CDATA sections
    'as appropriate
    Dim reader As XmlValidatingReader = Nothing
    Dim writer As XmlTextWriter = Nothing
    Dim sw As StringWriter = Nothing
    Array.Sort(cdataSections)
    Try
      reader = New XmlValidatingReader(Me.GetXml(), XmlNodeType.Document, Nothing)
      sw = New StringWriter
      writer = New XmlTextWriter(sw)
      writer.Formatting = Formatting.Indented
      reader.ValidationType = ValidationType.None
      'Expand character entities that will be in CDATA sections
      'so that characters such as &lt;script&gt; change to <script>
      reader.EntityHandling = EntityHandling.ExpandCharEntities
      Dim currentElement As String = [String].Empty
      While reader.Read()
        Select Case reader.NodeType
          Case XmlNodeType.Element
            currentElement = reader.Name
            writer.WriteStartElement(currentElement)
            writer.WriteAttributes(reader, False)
          Case XmlNodeType.Text
            If Array.BinarySearch(cdataSections, currentElement) < 0 Then
              writer.WriteString(reader.Value)
            Else
              writer.WriteCData(reader.Value)
            End If
          Case XmlNodeType.EndElement
            writer.WriteEndElement()
          Case Else
        End Select
      End While
    Catch exp As Exception
      Return exp.Message
    Finally
      reader.Close()
      writer.Close()
    End Try
    Return sw.ToString()
  End Function
End Class
