<%@Page Language="VB" Debug="True" %>

<%-------------------------------------------------------------%>

<script runat="server">

Sub Page_Load()

  ' add onclick client-side event attribute to button control
  btnOneClick.Attributes.Add("onclick", "return buttonClick(this);")

  ' add onsubmit client-side event attribute to enclosing form
  frmMain.Attributes.Add("onsubmit", "return formSubmit(this);")

  If Page.IsPostBack Then

    ' collect session and viewstate counter values
    Dim sPageLoads As String = Session("PageLoads")
    Dim sPageIndex As String = ViewState("PageIndex")

    If sPageLoads = "" Then

      lblMsg.Text &= "<b>WARNING:</b> Session support is not available."

    Else

      Dim iPageLoads As Integer = Integer.Parse(sPageLoads)
      Dim iPageIndex As Integer = Integer.Parse(sPageIndex)

      ' see if this is the first time the page was submitted
      If iPageLoads = iPageIndex Then

        lblMsg.Text &= "Thank you. Your input [" & iPageLoads.ToString() & "] has been accepted."

        ' *************************************
        ' perform required page processing here
        ' *************************************

        ' delay execution of page before sending response
        ' page is buffered by default so no content is sent
        ' to the client until page is complete
        Dim dNext As DateTime = DateTime.Now
        dNext = dNext.AddSeconds(7)
        While DateTime.Compare(dNext, DateTime.Now) > 0
          ' wait for specified number of seconds
          ' to simulate long/complex page execution
        End While

      Else

        lblMsg.Text &= "<b>WARNING:</b> You clicked the button " & (iPageLoads - iPageIndex + 1).ToString() & " times."

      End If

      ' increment counters for next page submission
      Session("PageLoads") = (iPageLoads + 1).ToString()
      ViewState("PageIndex") = (iPageLoads + 1).ToString()

    End If

  Else

    ' preset counters when page first loads
    Session("PageLoads") = "1"
    ViewState("PageIndex") = "1"
    lblMsg.Text="Click the button to submit your information"

  End If

End Sub

</script>

<%-------------------------------------------------------------%>
<%-------------------------------------------------------------%>

<html>
<head>

<!-- #include file="../global/style.inc" -->

<title>Creating a "One-Click" Button</title>

<%-------------------------------------------------------------%>
<script language="javascript">
<!--
var bButtonClicked = false;
var bFormSubmitted = false;

function buttonClick(ctrl) {
  // check value of first checkbox
  var theForm = document.forms[0];
  if(theForm.elements['chkNoDisable'].checked == false) {
    // first checkbox is not ticked
    // disable submit button
    ctrl.disabled = true;
    startTimer();
    theForm.submit();
  }
  // check value of second checkbox
  if(theForm.elements['chkAllowClick'].checked == false) {
    // second checkbox is not ticked
    if (bButtonClicked == false) {
      // first time button was clicked
      bButtonClicked = true;
      startTimer();
      return true;
    }
    else {
      // prevent button event from being executed
      return false;
    }
  }
  else {
    // second checkbox is ticked
    // allow button event to continue
    startTimer();
    return true;
  }
}

function formSubmit(ctrl) {
  // check value of third checkbox
  if(ctrl.elements['chkAllowSubmit'].checked == false) {
    // third checkbox is not ticked
    if (bFormSubmitted == false) {
      // first time form was submitted
      bFormSubmitted = true;
      startTimer();
      return true;
    }
    else {
      // prevent form from being submitted
      return false;
    }
  }
  else {
    // third checkbox is ticked
    // allow form to be submitted
    startTimer();
    return true;
  }
}

function startTimer() {
  // display "Please wait" message
  var label = document.getElementById('lblMsg');
  label.innerHTML = '<b>Please wait.</b>';
  // start interval timer for one second
  window.setTimeout('showProgress()', 1000);
}

function showProgress() {
  // update "Please wait" text
  var label = document.getElementById('lblMsg');
  label.innerHTML += '<b>.</b>';
  // restart interval timer for one second
  window.setTimeout('showProgress()', 1000);
}

//-->
</script>
<%-------------------------------------------------------------%>

</head>
<body>

<span class="heading">Creating a "One-Click" Button</span><hr />

<form id="frmMain" runat="server">

  <asp:TextBox id="txtTest" Text="Required value" runat="server" />
  <asp:Button id="btnOneClick" Text="Click me" runat="server" /><p />
  <asp:Label id="lblMsg" EnableViewState="False" runat="server" /><p />

  <asp:Checkbox id="chkNoDisable" runat="server"
       Text="Do not disable button after first click." /><br />
  <asp:Checkbox id="chkAllowClick" runat="server"
       Text="Allow multiple button clicks to be processed." /><br />
  <asp:Checkbox id="chkAllowSubmit" runat="server"
       Text="Allow page to be submitted again while still processing." />

</form>

<hr />
<!-- #include file="../global/viewsource.inc" -->
<!-- #include file="../global/footer.inc" -->

</body>
</html>

