<%@Page Language="VB" Debug="True" %>

<%-------------------------------------------------------------%>

<%@Register TagPrefix="ahh" TagName="ComboBox" Src="ascx\combo.ascx" %>

<%-------------------------------------------------------------%>

<script runat="server">

Sub Page_Load()

  If Not Page.IsPostback Then

    ' executed when page is first loaded
    ' select first combobox in radiobutton list
    optCbo.SelectedIndex = 0

    ' create ArrayList to populate comboboxes
    Dim aVals As New ArrayList()
    aVals.Add("aardvark")
    aVals.Add("baboon")
    aVals.Add("buffalo")
    aVals.Add("cheetah")
    aVals.Add("frog")
    aVals.Add("giraffe")
    aVals.Add("lion")
    aVals.Add("lynx")

    ' assign to DataSource of comboboxes
    cboTest1.DataSource = aVals
    cboTest2.DataSource = aVals
    cboTest3.DataSource = aVals

    ' set display format string for third combobox
    cboTest3.DataTextFormatString = "Animal '{0}'"

  End If

End Sub

<%-------------------------------------------------------------%>

Sub ShowMembers(oSender As Object, oArgs As EventArgs)

  ' get a reference to the selected comboxbox control
  Dim oCtrl As Object = Page.FindControl(optCbo.SelectedValue)

  ' call ShowMembers method of combobox control
  lblResult.Text = oCtrl.ShowMembers()

End Sub

<%-------------------------------------------------------------%>

Sub ShowSelected(oSender As Object, oArgs As EventArgs)

  ' get a reference to the selected comboxbox control
  Dim oCtrl As Object = Page.FindControl(optCbo.SelectedValue)

  ' use a StringBuilder to hold string for display
  Dim sResult As New StringBuilder("<b>Property Values:</b><br />")

  ' collect details of current selection from combobox
  sResult.Append("SelectedIndex: " & oCtrl.SelectedIndex & "<br />")
  sResult.Append("SelectedValue: " & oCtrl.SelectedValue & "<br />")
  sResult.Append("SelectedItem.Text: " & oCtrl.SelectedItem.Text & "<p />")

  ' collect all items in the combobox list
  sResult.Append("<b>ListItems Collection:</b><br />")
  For Each iItem as ListItem In oCtrl.Items
    sResult.Append(iItem.Text & "<br />")
  Next

  ' display results in the page
  lblResult.Text = sResult.ToString()

End Sub

<%-------------------------------------------------------------%>

Sub SetSelected(oSender As Object, oArgs As EventArgs)

  ' get a reference to the selected comboxbox control
  Dim oCtrl As Object = Page.FindControl(optCbo.SelectedValue)
  Dim iIndex As Integer

  Try

    ' check that user entered valid integer value
    iIndex = Integer.Parse(txtSelIndex.Text)

  Catch

    ' display error message in the page
    lblResult.Text = "<font color='red'><b>ERROR: </b>not a valid number</font>"

  End Try

  ' check that value is within range
  If iIndex < oCtrl.Items.Count Then

    ' set property of combobox control
    oCtrl.SelectedIndex = iIndex

  Else

    ' display error message in the page
    lblResult.Text = "<font color='red'><b>ERROR: </b>index out of range</font>"

  End If

End Sub

<%-------------------------------------------------------------%>

Sub SetSelVal(oSender As Object, oArgs As EventArgs)

  ' get a reference to the selected comboxbox control
  Dim oCtrl As Object = Page.FindControl(optCbo.SelectedValue)

  ' set property of combobox control
  oCtrl.SelectedValue = txtSelVal.Text

End Sub

<%-------------------------------------------------------------%>

Sub SetValue(oSender As Object, oArgs As EventArgs)

  ' get a reference to the selected comboxbox control
  Dim oCtrl As Object = Page.FindControl(optCbo.SelectedValue)

  ' set property of combobox control
  oCtrl.Items(2).Text = txtNewText.Text

End Sub

<%-------------------------------------------------------------%>

Sub SetWidth(oSender As Object, oArgs As EventArgs)

  ' get a reference to the selected comboxbox control
  Dim oCtrl As Object = Page.FindControl(optCbo.SelectedValue)

  ' check that user entered valid integer value
  Try

    ' set Width property of combobox control
    oCtrl.Width = Integer.Parse(txtWidth.Text)

    ' set Rows property of combobox control
    oCtrl.Rows = Integer.Parse(txtRows.Text)

  Catch

    ' display error message in the page
    lblResult.Text = "<font color='red'><b>ERROR: </b>not a valid number</font>"

  End Try

End Sub

</script>

<%-------------------------------------------------------------%>
<%-------------------------------------------------------------%>

<html>
<head>

<!-- #include file="../global/style.inc" -->

<style type="text/css">

  .bluegray {background-color:gainsboro;
             font-family:Tahoma,Helvetica,sans-serif;
             font-size:12; color:darkblue}

  .reverse  {background-color:black;
             font-family:Tahoma,Helvetica,sans-serif;
             font-size:medium; color:white;
             font-weight:bold}

</style>
<title>ComboBox User Control Features Demonstration</title>
</head>
<body>

<span class="heading">ComboBox User Control Features Demonstration</span>
<form runat="server">

  <hr />

  <table border="0"><tr><td align="right" valign="top">Simple Combo List Box:</td><td>
    <ahh:ComboBox id="cboTest1" IsDropDownCombo="False" runat="server" />
  </td></tr></table>

  <hr />

  <table border="0"><tr><td align="right" valign="top">Styled Drop-down Combo Box:</td><td>
    <ahh:ComboBox id="cboTest2" CssClass="bluegray" IsDropDownCombo="True" runat="server" />
  </td></tr></table>

  <hr />

  <table border="0"><tr><td align="right" valign="top">Wide and More Rows Drop-down<br />Combo Box with Larger Font:</td><td>
    <ahh:ComboBox id="cboTest3" CssClass="reverse" Width="300" Rows="10" IsDropDownCombo="True" runat="server" />
  </td></tr></table>

  <hr />

  <b>Select Combo Box and specify action to apply</b>:<p />
  <asp:RadioButtonList id="optCbo" RepeatLayout="Flow" RepeatDirection="Horizontal" RepeatColumns="3" runat="server" >
    <asp:ListItem Value="cboTest1" Text="Simple &nbsp;" />
    <asp:ListItem Value="cboTest2" Text="Styled &nbsp;" />
    <asp:ListItem Value="cboTest3" Text="Wide and More Rows" />
  </asp:RadioButtonList>
  <p />
  <asp:Button Text="&nbsp; &nbsp;" OnClick="ShowMembers" runat="server" /> &nbsp;
  Display the syntax by calling the ShowMembers method
  <p />
  <asp:Button Text="&nbsp; &nbsp;" OnClick="ShowSelected" runat="server" /> &nbsp;
  Show the selected index, value and list item properties
  <p />
  <asp:Button Text="&nbsp; &nbsp;" OnClick="SetSelected" runat="server" /> &nbsp;
  Set the selected index to
  <asp:TextBox id="txtSelIndex" Columns="2" Text="3" runat="server" />
  <p />
  <asp:Button Text="&nbsp; &nbsp;" OnClick="SetSelVal" runat="server" /> &nbsp;
  Set the selected value to
  <asp:TextBox id="txtSelVal" Columns="10" Text="giraffe" runat="server" />
  <p />
  <asp:Button Text="&nbsp; &nbsp;" OnClick="SetValue" runat="server" /> &nbsp;
  Set the text of the third item in the list to
  <asp:TextBox id="txtNewText" Columns="10" Text="bobcat" runat="server" />
  <p />
  <asp:Button Text="&nbsp; &nbsp;" OnClick="SetWidth" runat="server" /> &nbsp;
  Set the Width property to
  <asp:TextBox id="txtWidth" Columns="2" Text="400" runat="server" />
  and the Rows property to
  <asp:TextBox id="txtRows" Columns="2" Text="8" runat="server" />
  <p />
  <asp:Label id="lblResult" EnableViewState="False" runat="server" />

</form>

<hr><span class="cite">
[<a href="../global/viewsource.aspx?compsrc=combo.htm" target="_blank">view source</a>] &nbsp;
<!-- #include file="../global/footer.inc" -->
</body>
</html>
