<%@Page Language="VB" Debug="True" %>
<%@Import Namespace="System.Data" %>
<%@Import Namespace="System.Data.OleDb" %>

<%------------------------------------------------------------%>

<%@Register TagPrefix="ahh" TagName="ComboBox" Src="ascx\combo.ascx" %>

<%------------------------------------------------------------%>

<script runat="server">
Sub Page_Load()

  If Not Page.IsPostback Then

    ' populate combobox controls
    ' databind ArrayList to first one
    Dim aVals As New ArrayList()
    aVals.Add("aardvark")
    aVals.Add("baboon")
    aVals.Add("buffalo")
    aVals.Add("cheetah")
    aVals.Add("frog")
    aVals.Add("giraffe")
    aVals.Add("lion")
    aVals.Add("lynx")
    cboTest1.DataSource = aVals

    ' databind second combobox to a DataReader
    cboTest2.DataSource = GetDataReader()
    cboTest2.DataTextField = "ProductName"

    ' insert values directly into list for third combobox
    Dim oList As ListItemCollection = cboTest3.Items
    For iLoop As Integer = 1 To 9
      oList.Add(New ListItem("Item: " & iLoop.ToString()))
    Next
    oList.Insert(3, New ListItem("Inserted: 3a"))

  End If

End Sub

<%------------------------------------------------------------%>

Function GetDataReader() As OleDbDataReader

  ' get DataReader for rows from Northwind Products table
  Dim sConnect As String _
    = ConfigurationSettings.AppSettings("NorthwindOleDbConnectString")
  Dim sSelect As String _
    = "SELECT ProductName FROM Products WHERE ProductName LIKE 'c%'"
  Dim oConnect As New OleDbConnection(sConnect)

  Try

    oConnect.Open()
    Dim oCommand As New OleDbCommand(sSelect, oConnect)
    Return oCommand.ExecuteReader(CommandBehavior.CloseConnection)

  Catch oErr As Exception

    ' be sure to close connection if error occurs
    If oConnect.State <> ConnectionState.Closed  Then
      oConnect.Close()
    End If

    ' display error message in page
    lblErr.Text = oErr.Message

  End Try

End Function

</script>

<%------------------------------------------------------------%>
<%------------------------------------------------------------%>

<html>
<head>

<!-- #include file="../global/style.inc" -->

<title>Populating the ComboBox User Control</title>
</head>
<body>

<span class="heading">Populating the ComboBox User Control</span><hr />

<form runat="server">

  <ahh:ComboBox id="cboTest1" IsDropDownCombo="True" runat="server" />
  <ahh:ComboBox id="cboTest2" IsDropDownCombo="True" runat="server" />
  <ahh:ComboBox id="cboTest3" IsDropDownCombo="True" runat="server" />

  <asp:Label id="lblErr" EnableViewState="False" runat="server" />

</form>

<hr>
<span class="cite">
[<a href="../global/viewsource.aspx?compsrc=combo.htm" target="_blank">view source</a>] &nbsp;
<!-- #include file="../global/footer.inc" -->

</body>
</html>

