<%@Page Language="VB" Debug="True" %>
<%@Import Namespace="System.Data" %>
<%@Import Namespace="System.Data.SqlClient" %>

<%-------------------------------------------------------------%>

<script runat="server">

Sub UseStringValue(sender As Object, e As EventArgs)

  ' check if running on local server
  Dim sPath As String = Request.Url.ToString()
  If sPath.IndexOf("http://localhost/") <> 0 Then
    lblResult.Text = "<font color='red'><b>NOTE: </b>" _
                   & "this example can only be run from http://localhost</font>"
    Return
  End If

  ' get input value from String Textbox
  Dim sParam As String = txtString.Text

  ' declare SQL statement containing parameter
  Dim sSQL As String = "SELECT CustomerID, CompanyName, City, " _
                     & "Country FROM Customers " _
                     & "WHERE CustomerID LIKE '" & sParam & "'"

  ' get connection string, create connection and command
  Dim sConnect As String = _
    ConfigurationSettings.AppSettings("NorthwindSqlClientConnectString")
  Dim oCon As New SqlConnection(sConnect)
  Dim oCmd As New SqlCommand(sSQL, oCon)

  Try

    ' specify query type and open connection
    oCmd.CommandType = CommandType.Text
    oCon.Open()

    ' execute query and assign result to DataGrid
    dgr1.DataSource = oCmd.ExecuteReader()
    dgr1.DataBind()

    'close connection afterwards
    oCon.Close()

    ' display SQL statement in page
    lblResult.Text = "Executed: " & sSQL

  Catch oErr As Exception

    ' be sure to close connection if error occurs
    ' can call Close more than once if required - no exception
    ' is generated if Connection is already closed
    oCon.Close()
    lblResult.Text = "<font color='red'><b>ERROR: </b>" _
                   & oErr.Message & "</font>"

  End Try

End Sub

<%-------------------------------------------------------------%>

Sub UseParamValue(sender As Object, e As EventArgs)

  ' check if running on local server
  Dim sPath As String = Request.Url.ToString()
  If sPath.IndexOf("http://localhost/") <> 0 Then
    lblResult.Text = "<font color='red'><b>NOTE: </b>" _
                   & "this example can only be run from http://localhost</font>"
    Return
  End If

  ' get input value from Textbox
  Dim sParam As String = txtParam.Text

  ' declare SQL statement containing parameter
  Dim sSQL As String = "SELECT CustomerID, CompanyName, City, " _
                     & "Country FROM Customers " _
                     & "WHERE CustomerID LIKE @CustomerID"

  ' get connection string, create connection and command
  Dim sConnect As String = _
    ConfigurationSettings.AppSettings("NorthwindSqlClientConnectString")
  Dim oCon As New SqlConnection(sConnect)
  Dim oCmd As New SqlCommand(sSQL, oCon)

  Try

    ' specify query type, add parameter and open connection
    oCmd.Parameters.Add("@CustomerID", sParam)
    oCmd.CommandType = CommandType.Text
    oCon.Open()

    ' execute query and assign result to DataGrid
    dgr1.DataSource = oCmd.ExecuteReader()
    dgr1.DataBind()

    'close connection afterwards
    oCon.Close()

    ' display SQL statement in page and show hint
    lblResult.Text = "Executed: " & sSQL
    lblHint.Visible = True

  Catch oErr As Exception

    ' be sure to close connection if error occurs
    ' can call Close more than once if required - no exception
    ' is generated if Connection is already closed
    oCon.Close()
    lblResult.Text = "<font color='red'><b>ERROR: </b>" _
                   & oErr.Message & "</font>"

  End Try

End Sub

</script>

<%-------------------------------------------------------------%>

<html>
<head>
<!-- #include file="../global/style.inc" -->
<title>Using Parameters with SQL Statements</title>
</head>
<body>

<span class="heading">Using Parameters with SQL Statements</span><hr />

<form runat="server">

  Text string value:
  <asp:Textbox id="txtString" Size="30" Text="BO%" runat="server" />
  <asp:Button id="btnString" Text="Go" runat="server"
       OnClick="UseStringValue" /><p />

  Parameter value:
  <asp:Textbox id="txtParam" Size="30" Text="BO%" runat="server" />
  <asp:Button id="btnParam" Text="Go" runat="server"
       OnClick="UseParamValue" /><p />

  <asp:DataGrid id="dgr1" runat="server" /><p />

  <asp:Label id="lblResult" EnableViewState="False" runat="server" /><p />

  <asp:Label id="lblHint" Visible="False" runat="server">
    Now try with: <b>' or '1'='1</b><br />
    or: <b>'; update customers set city='here!' where customerID like 'BOLID</b><br />
  </asp:Label>

</form>

<span class="cite">
Remember to edit the connection strings in web.config file for the Northwind
sample database, and<br />install the ParamOrderProc stored procedure using the SQL
script provided in the databases folder.
</span>
<hr />
<!-- #include file="../global/viewsource.inc" -->
<!-- #include file="../global/footer.inc" -->

</body>
</html>

