/****** Object:  Stored Procedure dbo.ParamDefaultProc    Script Date: 22/10/2003 17:28:16 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[ParamDefaultProc]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[ParamDefaultProc]
GO

/****** Object:  Login anon    Script Date: 22/10/2003 17:28:16 ******/
if not exists (select * from master.dbo.syslogins where loginname = N'anon')
BEGIN
  declare @logindb nvarchar(132), @loginlang nvarchar(132) select @logindb = N'master', @loginlang = N'us_english'
  if @logindb is null or not exists (select * from master.dbo.sysdatabases where name = @logindb)
    select @logindb = N'master'
  if @loginlang is null or (not exists (select * from master.dbo.syslanguages where name = @loginlang) and @loginlang <> N'us_english')
    select @loginlang = @@language
  exec sp_addlogin N'anon', null, @logindb, @loginlang
END
GO

/****** Object:  User anon    Script Date: 22/10/2003 17:28:16 ******/
if not exists (select * from dbo.sysusers where name = N'anon' and uid < 16382)
  EXEC sp_grantdbaccess N'anon', N'anon'
GO

SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS OFF
GO

/****** Object:  Stored Procedure dbo.ParamDefaultProc    Script Date: 22/10/2003 17:28:16 ******/
CREATE PROCEDURE ParamDefaultProc
  @OrderID int,                        @CustomerID nchar(5),
  @OrderDate datetime = NULL,          @RequiredDate datetime = NULL,
  @ShippedDate datetime = NULL,        @ShipVia int = 1,
  @Freight money = 25,                 @ShipName nvarchar(40) = NULL,
  @ShipAddress nvarchar(60) = NULL,    @ShipCity nvarchar(15) = NULL,
  @ShipPostalCode nvarchar(10) = NULL, @ShipCountry nvarchar(15) = NULL
AS
IF @OrderDate IS NULL
  BEGIN
    SET @OrderDate = GETDATE()
  END
IF @RequiredDate IS NULL
  BEGIN
    RAISERROR('Procedure ParamDefaultProc: you must
              provide a value for the RequiredDate',
              1, 1) WITH LOG
    RETURN
  END
IF @ShipName IS NULL
  BEGIN
    SELECT @ShipName = CompanyName,  @ShipAddress = Address,
           @ShipCity = City,         @ShipPostalCode = PostalCode,
           @ShipCountry = Country
           FROM Customers
           WHERE CustomerID = @CustomerID
  END
UPDATE Orders SET
  OrderDate = @OrderDate,           RequiredDate = @RequiredDate,
  ShippedDate = @ShippedDate,       ShipVia = @ShipVia,
  Freight = @Freight,               ShipName = @ShipName,
  ShipAddress = @ShipAddress,       ShipCity = @ShipCity,
  ShipPostalCode = @ShipPostalCode, ShipCountry = @ShipCountry
WHERE
  OrderID = @OrderID

SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS ON
GO

GRANT  EXECUTE  ON [dbo].[ParamDefaultProc]  TO [anon]
GO

