<%@Page Language="VB" Debug="True" %>
<%@Register TagPrefix="ahh" Tagname="ClientDialog"
            Src="ascx/adaptiveclientdialog.ascx" %>
<%-------------------------------------------------------------%>

<script runat="server">

Sub Page_Load()

  ' use options selected in page for all params
  Dim iDlgType As Integer = selDlgType.SelectedIndex
  Dim sMessage As String = txtMessage.Text
  Dim sTitle As String = txtTitle.Text
  Dim bCancel as Boolean = optCancel.Checked
  Dim bSubmit as Boolean = optSubmit.Checked

  ' attach dialog event to control every time page loads
  ctlDialog.AttachDialog(iDlgType, "btnTest", "onclick", sMessage, sTitle, bCancel, bSubmit)

  If Page.IsPostback Then

    ' collect the results from the dialogs
    lblResult.Text = ctlDialog.GetDialogResult("btnTest").ToString()

  End If

End Sub

</script>

<%-------------------------------------------------------------%>

<html>
<head>
<!-- #include file="../global/style.inc" -->
<title>Browser-Adaptive Dialogs from a User Control</title>
</head>
<body>

<ahh:ClientDialog id="ctlDialog" runat="server" />

<span class="heading">Browser-Adaptive Dialogs from a User Control</span><hr />

<form id="frmMain" runat="server">

  Select from the options below and click here:
  <asp:Button id="btnTest" Text="Test" runat="server" />
  <p />
  The value detected on postback is:<b>
  <asp:Label id="lblResult" EnableViewState="False" runat="server" /></b><p />
  <hr />

  DialogType:
  <asp:DropDownList id="selDlgType" runat="server" AutoPostback="True">
    <asp:ListItem Text="Alert" Value="0" />
    <asp:ListItem Text="VBInfoMessage" Value="1" />
    <asp:ListItem Text="VBWarningMessage" Value="2" />
    <asp:ListItem Text="VBCriticalMessage" Value="3" />
    <asp:ListItem Text="Confirm" Value="4" />
    <asp:ListItem Text="VBOKCancel" Value="5" />
    <asp:ListItem Text="VBYesNo" Value="6" />
    <asp:ListItem Text="VBRetryCancel" Value="7" />
    <asp:ListItem Text="Prompt" Value="8" />
    <asp:ListItem Text="VBInput" Value="9" />
  </asp:DropDownList>
  <p />
  MessageText:
  <asp:Textbox id="txtMessage" Text="This is the text to display" Columns="50" AutoPostback="True" runat="server" />
  <p />
  Title:
  <asp:Textbox id="txtTitle" Text="Your Title" Columns="25" AutoPostback="True" runat="server" />
  <p />
  Cancel event after dialog is closed?
  <asp:RadioButton Text="Yes" id="optCancel" GroupName="CancelOptions" AutoPostback="True" runat="server" />&nbsp;
  <asp:RadioButton Text="No" id="optNoCancel" GroupName="CancelOptions" Checked="True" AutoPostback="True" runat="server" />
  <p />
  Submit &lt;form&gt; after dialog is closed?
  <asp:RadioButton Text="Yes" id="optSubmit" GroupName="SubmitOptions" AutoPostback="True" runat="server" />&nbsp;
  <asp:RadioButton Text="No" id="optNoSubmit" GroupName="SubmitOptions" Checked="True" AutoPostback="True" runat="server" />
  <p />
  Click to <asp:Button Text="submit" runat="server" /> form manually.
  <p />

</form>

<span class="cite">NOTE: Remember to copy the client-side script files named 'adaptive-dialog.js' and 'adaptive-dialog.vbs'<br />
into the subfolder named 'custom' within the 'aspnet_client' folder of your Web site.</span>

<hr><span class="cite">
[<a href="../global/viewsource.aspx?compsrc=adaptiveclientdialog.htm" target="_blank">view source</a>] &nbsp;
<!-- #include file="../global/footer.inc" -->

</body>
</html>

