<%@Page Language="VB" Debug="True" %>

<script runat="server">

' change method of server-side form
Sub ChangeMethod(sender As Object, args As EventArgs)
  frmMain.Method = optMethod.SelectedValue
End Sub

' redirect to next page and end current response
Sub DoRedirect(sender As Object, args As EventArgs)
  Response.Redirect("catchrequest.aspx", True)
End Sub

' redirect to next page and end current response
Sub DoRedirectValues(sender As Object, args As EventArgs)
  ' create query string containing control values
  Dim sQuery As String = "?txtThis=" & txtThis.Text _
    & "&lstThis=" & lstThis.SelectedValue _
    & "&ddlThis=" & ddlThis.SelectedValue _
    & "&optMethod=" & optMethod.SelectedValue
  ' get setting of "method" option buttons
  If optMethod.SelectedValue = "post" Then
    ' redirect to a page that will post them to the "catch" page
    Response.Redirect("postrequest.aspx" & sQuery, True)
  Else
    ' redirect straight to the "catch" page
    Response.Redirect("catchrequest.aspx" & sQuery, True)
  End If
End Sub

</script>

<!------------------------------------------------------------->

<html>
<head>
<!-- #include file="../global/style.inc" -->
<title>Accessing Request Values in Another Page</title>

<script language='JavaScript'>
<!--
function changeAction(sURL) {
  var theForm = document.getElementById('frmMain');
  theForm.action = sURL;
}
//-->
</script>

</head>
<body>
<span class="heading">Accessing Request Values in Another Page</span><hr />

<form id="frmMain" runat="server">

Textbox (ID="txtThis"):
<asp:TextBox id="txtThis" Text="Some text" runat="server"/>
<p />
ListBox (ID="lstThis"):
<asp:ListBox id="lstThis" runat="server">
  <asp:ListItem Text="This is item 1" Value="Item1" />
  <asp:ListItem Text="This is item 2" Value="Item2" selected="True" />
  <asp:ListItem Text="This is item 3" Value="Item3" />
  <asp:ListItem Text="This is item 4" Value="Item4" />
</asp:ListBox>
<p />
DropDownList (ID="ddlThis"):
<asp:DropDownList id="ddlThis" runat="server">
  <asp:ListItem Text="This is item 1" Value="Item1" />
  <asp:ListItem Text="This is item 2" Value="Item2" />
  <asp:ListItem Text="This is item 3" Value="Item3" selected="True" />
  <asp:ListItem Text="This is item 4" Value="Item4" />
</asp:DropDownList>
<p />
Method attribute for &lt;form&gt;:
<asp:RadioButtonList id="optMethod" runat="server"
     RepeatDirection="Horizontal" RepeatLayout="Flow"
     OnSelectedIndexChanged="ChangeMethod" AutoPostback="True">
  <asp:ListItem Text="POST (default)" Value="post" Selected="True" />
  <asp:ListItem Text="GET" Value="get" />
</asp:RadioButtonList>
<p />
<input type="submit" name="btnChangeAction"
       value="Submit (normal)"
       onclick="changeAction('catchrequest.aspx')" /> &nbsp;
<input type="submit" name="btnActionNoMAC"
       value="Submit (no MAC check)"
       onclick="changeAction('catchnomac.aspx')" /><p />
<asp:Button id="btnRedirect" Text="Redirect" runat="server"
     OnClick="DoRedirect" /> &nbsp;
<asp:Button id="btnRedirectValues" Text="Redirect with Values" runat="server"
     OnClick="DoRedirectValues" />
</form>

<hr /><span class="cite">
[<a href="../global/viewsource.aspx?compsrc=postrequest.htm" target="_blank">view source</a>] &nbsp;
<!-- #include file="../global/footer.inc" -->
</body>
</html>
