<%@Page Language="VB" ClassName="ReferencePage" Debug="True" %>

<script runat="server">

' public properties exposed to other pages
Public ReadOnly Property TextValue As String
  Get
    Return txtThis.Text
  End Get
End Property

Public ReadOnly Property ListIndex As Integer
  Get
    Return lstThis.SelectedIndex
  End Get
End Property

Public ReadOnly Property DropList As DropDownList
  Get
    Return ddlThis
  End Get
End Property

' initiate transfer to next page when button clicked
Sub DoTransferTrue(sender As Object, args As EventArgs)
  ' use True to specify that Request collections are *not* cleared
  ' in fact True is the default anyway (the SDK is wrong on this)
  Server.Transfer("catchreference.aspx", True)
End Sub

' initiate transfer to next page when button clicked
Sub DoTransferFalse(sender As Object, args As EventArgs)
  ' use False so that no Request values are passed
  ' page properties are still available in target page
  Server.Transfer("catchreference.aspx", False)
End Sub

' change method of server-side form
Sub ChangeMethod(sender As Object, args As EventArgs)
  frmMain.Method = optMethod.SelectedValue
End Sub


</script>

<!------------------------------------------------------------->

<html>
<head>
<!-- #include file="../global/style.inc" -->
<title>Exposing Page Values via a Reference</title>
</head>
<body>
<span class="heading">Exposing Page Values via a Reference</span><hr />

<form id="frmMain" runat="server">

Textbox (ID="txtThis"):
<asp:TextBox id="txtThis" Text="Some text" runat="server"/>
<p />
ListBox (ID="lstThis"):
<asp:ListBox id="lstThis" runat="server">
  <asp:ListItem Text="This is item 1" Value="Item1" />
  <asp:ListItem Text="This is item 2" Value="Item2" selected="True" />
  <asp:ListItem Text="This is item 3" Value="Item3" />
  <asp:ListItem Text="This is item 4" Value="Item4" />
</asp:ListBox>
<p />
DropDownList (ID="ddlThis"):
<asp:DropDownList id="ddlThis" runat="server">
  <asp:ListItem Text="This is item 1" Value="Item1" />
  <asp:ListItem Text="This is item 2" Value="Item2" />
  <asp:ListItem Text="This is item 3" Value="Item3" selected="True" />
  <asp:ListItem Text="This is item 4" Value="Item4" />
</asp:DropDownList>
<p />
Method attribute for &lt;form&gt;:
<asp:RadioButtonList id="optMethod" runat="server"
     RepeatDirection="Horizontal" RepeatLayout="Flow"
     OnSelectedIndexChanged="ChangeMethod" AutoPostback="True">
  <asp:ListItem Text="POST (default)" Value="post" Selected="True" />
  <asp:ListItem Text="GET" Value="get" />
</asp:RadioButtonList>
<p />
<asp:Button id="btnTransferTrue" Text="Transfer with Request" runat="server"
     OnClick="DoTransferTrue" /> &nbsp;
<asp:Button id="btnTransferFalse" Text="Transfer no Request" runat="server"
     OnClick="DoTransferFalse" />
</form>

<hr /><span class="cite">
[<a href="../global/viewsource.aspx?compsrc=catchreference.htm" target="_blank">view source</a>] &nbsp;
<!-- #include file="../global/footer.inc" -->
</body>
</html>
