<%@Page Language="VB" Debug="True" %>
<%@Import Namespace="System.Data" %>
<%@Import Namespace="System.Data.SqlClient" %>

<script runat="server">

Sub Page_Load()
  ' check that the browser is IE 5 or higher
  If Request.Browser.Browser <> "IE" _
  Or Request.Browser.MajorVersion < 5 Then
    ' display message and hide input controls
    lblEnter.Text = "Sorry, this page requires Internet Explorer 5 or higher"
    txtCustomer.Visible = False
    btnGo.Visible = False
  End If
End Sub

Sub ShowOrders(sender As Object, args As EventArgs)

  ' bind DataGrid to contents of DataSet in user's Session
  dgrOrders.DataSource = CType(Session("thedata"), DataSet)
  dgrOrders.Datamember = "OrderDetails"
  dgrOrders.DataBind()

End Sub

</script>

<!------------------------------------------------------------->

<html>
<head>
<!-- #include file="../global/style.inc" -->
<title>Displaying Staged Page Load Progress</title>

<script language='JavaScript'>
<!--
var oResult;
var oHTTP;
var sCustID;

function getResults() {
  // get reference to "result" label and texbox value
  oResult = document.getElementById('spnResult');
  var oTextbox = document.getElementById('txtCustomer');
  sCustID = oTextbox.value;
  if (! sCustID == '') {
    // hide DataGrid control
    var oElem = document.getElementById('dgrOrders');
    if (oElem != null) oElem.style.visibility = 'hidden';
    // get Customers data
    fetchData(1)
  }
  else
    oResult.innerText = 'No customer ID specified';
  // return false to prevent button from submitting form
  return false;
}

function fetchData(iStep) {
  // create instance of a new XMLHTTP object because we
  // can't change readystate handler on existing instance
  oHTTP = new ActiveXObject('Microsoft.XMLHTTP');
  if (oHTTP != null) {
    // update status display and build data page URL
    setCurrent(iStep);
    var sURL = 'stagedfetchpage.aspx?custid=' + sCustID
             + '&step=' + iStep.toString();
    // set correct handler for XMLHTTP instance
    switch (iStep) {
      case 1: {
        oHTTP.onreadystatechange = gotCustomers;
        break;
        }
      case 2: {
        oHTTP.onreadystatechange = gotOrders;
        break;
        }
      case 3: {
        oHTTP.onreadystatechange = gotDetails;
        break;
        }
      case 4: {
        oHTTP.onreadystatechange = gotTotal;
        }
    }
    // open HTTP connection and send async request
    oHTTP.open('GET', sURL, true);
    oHTTP.send()
  }
  else
    oResult.innerText = 'Cannot create XMLHTTP object';
}

function gotCustomers() {
  // see if loading is complete
  if (oHTTP.readyState == 4) {
    // check if there was an error
    if (oHTTP.status == 200) {
      // update status display and fetch next set of results
      setCompleted(1);
      fetchData(2);
    }
    else
      oResult.innerText = oHTTP.responseText;
  }
}

function gotOrders() {
  // see if loading is complete
  if (oHTTP.readyState == 4) {
    // check if there was an error
    if (oHTTP.status == 200) {
      // update status display and fetch next set of results
      setCompleted(2);
      fetchData(3);
    }
    else
      oResult.innerText = oHTTP.responseText;
  }
}

function gotDetails() {
  // see if loading is complete
  if (oHTTP.readyState == 4) {
    // check if there was an error
    if (oHTTP.status == 200) {
      // update status display and fetch next set of results
      setCompleted(3);
      fetchData(4);
    }
    else
      oResult.innerText = oHTTP.responseText;
  }
}

function gotTotal() {
  // see if loading is complete
  if (oHTTP.readyState == 4) {
    // check if there was an error
    if (oHTTP.status == 200) {
      // update status display
      setCompleted(4);
      // display result in page and show Orders button
      oResult.innerText = 'Total value of all orders $ '
                        + oHTTP.responseText;
      var oElem = document.getElementById('btnOrders');
      oElem.style.visibility = 'visible';
    }
    else
      oResult.innerText = oHTTP.responseText;
  }
}

function setCurrent(iStep) {
  // get reference to image and change to "arrow"
  // using image pre-loaded in hidden <img> element
  var oImg = document.getElementById('imgThis');
  var oElem = document.getElementById('img' + iStep.toString());
  oElem.src = oImg.src;
  // get reference to span and change text to bold
  oElem = document.getElementById('spn' + iStep.toString());
  oElem.style.fontWeight = 'bold';
}

function setCompleted(iStep) {
  // get reference to image and change to "tick"
  // using image pre-loaded in hidden <img> element
  var oImg = document.getElementById('imgTrue');
  var oElem = document.getElementById('img' + iStep.toString());
  oElem.src = oImg.src;
  // get reference to span and change text back to normal
  oElem = document.getElementById('spn' + iStep.toString());
  oElem.style.fontWeight = '';
}

//-->
</script>

</head>
<body>

<span class="heading">Displaying Staged Page Load Progress</span><hr />

<form runat="server">

<table border="0">
<tr><td align="right" valign="top">

  <!----- form for selecting customer ----->
  <asp:Label id="lblEnter" Text="Enter Customer ID:" runat="server" />
  <asp:Textbox id="txtCustomer" runat="server" /><br />
  <input id="btnGo" type="submit" value="Calculate" runat="server"
         onclick="return getResults();" />

</td><td>&nbsp; &nbsp; &nbsp; &nbsp;</td><td valign="top">

  <!----- "please wait" display ----->
  <table border="0">
  <tr>
    <td><img id="img1" src="../images/False.gif" width="12" height="12" hspace="5" /></td>
    <td><span id="spn1">Loading Customer Data</span></td>
  </tr><tr>
    <td><img id="img2" src="../images/False.gif" width="12" height="12" hspace="5" /></td>
    <td><span id="spn2">Loading Orders Data</span></td>
  </tr><tr>
    <td><img id="img3" src="../images/False.gif" width="12" height="12" hspace="5" /></td>
    <td><span id="spn3">Loading Order Details</span></td>
  </tr><tr>
    <td><img id="img4" src="../images/False.gif" width="12" height="12" hspace="5" /></td>
    <td><span id="spn4">Calculating Total</span></td>
  </tr>
  </table>

</td></tr><tr><td colspan="3">

  <!----- section for displaying total ----->
  <div id="divResult">
    <b><span id="spnResult"></span></b><p />
  </div>

  <!----- section for displaying orders ----->
  <div id="divOrderList">
    <asp:Button id="btnOrders" style="visibility:hidden"
         Text="Show Orders" OnClick="ShowOrders" runat="server" />
    <asp:DataGrid id="dgrOrders" EnableViewState="False" runat="server" /><p />
  </div>

</td></tr>
</table>

</form>

<span class="cite">
Remember to edit the connection strings in web.config file
for the Northwind sample database.
</span>
<hr /><span class="cite">
[<a href="../global/viewsource.aspx?compsrc=stagedfetchpage.htm" target="_blank">view source</a>] &nbsp;
<!-- #include file="../global/footer.inc" -->

<img id="imgTrue" style="visibility:hidden" src="../images/True.gif" />
<img id="imgThis" style="visibility:hidden" src="../images/This.gif" />

</body>
</html>

