<%@Page Language="VB" Debug="True" %>

<%-------------------------------------------------------------%>

<script runat="server">

Sub Page_Load()

  Dim sMask As String = selMask.SelectedValue
  Dim sFont As String = "Courier New"
  Dim sSize As String = selSize.SelectedValue

  txtMaskEdit.Text = ""
  txtMaskEdit.Style("font-family") = sFont
  txtMaskEdit.Style("font-size") = sSize & "pt"

  Dim sQuery As String = sMask
  sQuery = sQuery.Replace("a", "_")
  sQuery = sQuery.Replace("A", "_")
  sQuery = sQuery.Replace("l", "_")
  sQuery = sQuery.Replace("L", "_")
  sQuery = sQuery.Replace("n", "_")
  sQuery = sQuery.Replace("?", "_")
  sQuery = Server.UrlEncode(sQuery)
  sFont = Server.UrlEncode(sFont)

  txtMaskEdit.Style("background-image") = "url(mask-image.aspx?mask=" _
    & sQuery & "&font=" & sFont & "&size=" & sSize & "&cols=" _
    & txtMaskEdit.Columns.ToString() & ")"

  Dim sTip As String = sMask
  sTip = sTip.Replace("a", "[a]")
  sTip = sTip.Replace("A", "[A]")
  sTip = sTip.Replace("l", "[l]")
  sTip = sTip.Replace("L", "[L]")
  sTip = sTip.Replace("n", "[n]")
  sTip = sTip.Replace("?", "[?]")
  txtMaskEdit.ToolTip = "Mask: " & sTip & vbCrlf & " where:" _
    & vbCrlf & "[a] = any alphanumeric character (0-9, A-Z, a-z)" _
    & vbCrlf & "[A] = an uppercase alphanumeric character (0-9, A-Z)" _
    & vbCrlf & "[l] = any letter character (A-Z, a-z)" _
    & vbCrlf & "[L] = an uppercase letter character (A-Z)" _
    & vbCrlf & "[n] = any numeric character (0-9)" _
    & vbCrlf & "[?] = any character"

  txtMaskEdit.Attributes.Add("onkeydown", "return doKeyDown(event, this, '" & sMask & "')")
  txtMaskEdit.Attributes.Add("onkeypress", "return doKeyPress(event, this, '" & sMask & "')")
  txtMaskEdit.Attributes.Add("onkeyup", "return doKeyUp(event, this, '" & sMask & "')")
  txtMaskEdit.Attributes.Add("onfocus", "return doFocus(event, this, '" & sMask & "')")

End Sub

</script>

<%-------------------------------------------------------------%>
<%-------------------------------------------------------------%>

<html>
<head>

<!-- #include file="../global/style.inc" -->

<title>Simple Masked Edit Control Demonstration</title>

<%-------------------------------------------------------------%>
<script language='javascript'>

var sMaskSet = 'aAlLn?'
var sUAscii = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
var bStarting = true;

function doKeyDown(e, textbox, sMask) {
  // trap and cancel keys that are not appropriate
  var iKeyCode = 0;    // collect key code
  if (window.event) iKeyCode = window.event.keyCode;
  else if (e) iKeyCode = e.which;
  if (iKeyCode == 32 || iKeyCode == 39 || iKeyCode == 35
  || iKeyCode == 8 || iKeyCode == 9)
    return true;       // space left end backspace tab
  if (iKeyCode < 47)   // non-printable character
    return false;
}

function doKeyPress(e, textbox, sMask) {
  window.status = '';
  var iKeyCode = 0;    // collect key code
  if (window.event) iKeyCode = window.event.keyCode;
  else if (e) iKeyCode = e.which;
  // check if mask already filled, and not backspace
  var iLength = textbox.value.length;
  if ((iLength == sMask.length) && (iKeyCode != 8))
    return false;
  // get mask character for this position in textbox
  var sMaskChar = sMask.charAt(iLength);
  // see if it's a special character
  if (sMaskSet.indexOf(sMaskChar) > -1) {
    // masked character required
    switch (sMaskChar) {
      case 'a':   // any alphanumeric character
        if ((iKeyCode > 47 && iKeyCode < 58)
        || (iKeyCode > 64 && iKeyCode < 91)
        || (iKeyCode > 96 && iKeyCode < 123))
          return true
        else return false;
      case 'A':   // uppercase alphanumeric character
        if ((iKeyCode > 47 && iKeyCode < 58)
        || (iKeyCode > 64 && iKeyCode < 91))
          return true
        else if (iKeyCode > 96 && iKeyCode < 123) {
          textbox.value += sUAscii.charAt(iKeyCode - 97);
          return false;
        }
        else return false;
      case 'l':   // any letter
        if ((iKeyCode > 64 && iKeyCode < 91)
        || (iKeyCode > 96 && iKeyCode < 123))
          return true
        else
          return false;
      case 'L':   // uppercase letter
        if (iKeyCode > 64 && iKeyCode < 91)
          return true
        else if (iKeyCode > 96 && iKeyCode < 123) {
          textbox.value += sUAscii.charAt(iKeyCode - 97);
          return false;
        }
        else return false;
      case 'n':   // any numeric character
        if (iKeyCode > 47 && iKeyCode < 58)
          return true
        else return false;
      case '?':   // any character
        return true;
      default: return false;
    }
  }
  else
    return true;
}

function doKeyUp(e, textbox, sMask) {
  if (bStarting != true) {
     var iKeyCode = 0;    // collect key code
     if (window.event) iKeyCode = window.event.keyCode;
     else if (e) iKeyCode = e.which;
     if (iKeyCode < 47 && iKeyCode != 32) return;
  }
  // check if next mask characters are literals
  // and add to text box if they are
  while ((textbox.value.length < sMask.length) &&
  (sMaskSet.indexOf(sMask.charAt(textbox.value.length)) == -1)) {
    textbox.value += sMask.charAt(textbox.value.length);
  }
  var sNext;
  if (textbox.value.length == sMask.length)
    sNext = 'Complete'
  else
    switch (sMask.charAt(textbox.value.length)) {
     case 'a':
       sNext = 'Expecting any alphanumeric character (0-9, A-Z, a-z)';
       break;
     case 'A':
       sNext = 'Expecting an uppercase alphanumeric character (0-9, A-Z)';
       break;
     case 'l':
       sNext = 'Expecting any letter (A-Z, a-z)';
       break;
     case 'L':
       sNext = 'Expecting an uppercase letter (A-Z)';
       break;
     case 'n':
       sNext = 'Expecting any numeric character (0-9)';
       break;
     case '?':
       sNext = 'Expecting any character';
       break;
     default: sNext = '';
    }
  window.status = sNext;
}

function doFocus(e, textbox, sMask) {
  bStarting = true;
  doKeyUp(e, textbox, sMask);
  bStarting = false;
}


</script>
<%-------------------------------------------------------------%>

</head>
<body>

<span class="heading">Simple Masked Edit Control Demonstration</span><hr />

<form id="frmMain" runat="server">

  Select Mask and Font size in the lists below and<br />
  press TAB to type in the masked edit box. The<br />
  browser status bar shows the expected character.<p />
  <asp:DropDownList id="selMask" AutoPostback="True" runat="server">
    <asp:ListItem Value="nnnn-nn-nnTnn:nn:nn" Text="UTC Date and Time" />
    <asp:ListItem Value="Qnnnnn-LLnn" Text="Part Number" />
    <asp:ListItem Value="(nnn)-nnn-nnnn" Text="US Phone Number" />
    <asp:ListItem Value="LLn? nLL" Text="UK Postal Code" />
  </asp:DropDownList>
  <asp:DropDownList id="selSize" AutoPostback="True" runat="server">
    <asp:ListItem Value="10" Text="10 pt" />
    <asp:ListItem Value="12" Text="12 pt" />
    <asp:ListItem Value="16" Text="16 pt" />
  </asp:DropDownList><p />

  <asp:TextBox id="txtMaskEdit" Columns="25" runat="server" /> <p />

</form>

<hr />
<!-- #include file="../global/viewsource.inc" -->
<!-- #include file="../global/footer.inc" -->

</body>
</html>

